-- name: [CS] BOWSETTE
-- description: Transition is not gonna fix her (compatible with Bowser Moveset!) \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!


local E_MODEL_BOWSETTE = smlua_model_util_get_id("bowsette_geo")

local TEX_BOWSETTE = get_texture_info("bowsette_icon")

local TEXT_MOD_NAME = "[CS] BOWSETTE"

local VOICETABLE_BOWSETTE = {
[CHAR_SOUND_ATTACKED] = 'CHAR_SOUND_ATTACKED.ogg',
[CHAR_SOUND_COUGHING1] = 'CHAR_SOUND_COUGHING1.ogg',
[CHAR_SOUND_COUGHING2] = 'CHAR_SOUND_COUGHING2.ogg',
[CHAR_SOUND_COUGHING3] = 'CHAR_SOUND_COUGHING3.ogg',
[CHAR_SOUND_DOH] = 'CHAR_SOUND_DOH.ogg',
[CHAR_SOUND_DROWNING] = 'CHAR_SOUND_DROWNING.ogg',
[CHAR_SOUND_DYING] = 'CHAR_SOUND_DYING.ogg',
[CHAR_SOUND_EEUH] = 'CHAR_SOUND_EEUH.ogg',
[CHAR_SOUND_GROUND_POUND_WAH] = 'CHAR_SOUND_GROUND_POUND_WAH.ogg',
[CHAR_SOUND_HAHA] = 'CHAR_SOUND_HAHA.ogg',
[CHAR_SOUND_HAHA_2] = 'CHAR_SOUND_HAHA_2.ogg',
[CHAR_SOUND_HERE_WE_GO] = 'CHAR_SOUND_HERE_WE_GO.ogg',
[CHAR_SOUND_HOOHOO] = 'CHAR_SOUND_HOOHOO.ogg',
[CHAR_SOUND_HRMM] = 'CHAR_SOUND_HRMM.ogg',
[CHAR_SOUND_IMA_TIRED] = 'CHAR_SOUND_IMA_TIRED.ogg',
[CHAR_SOUND_MAMA_MIA] = 'CHAR_SOUND_MAMA_MIA.ogg',
[CHAR_SOUND_LETS_A_GO] = 'CHAR_SOUND_LETS_A_GO.ogg',
[CHAR_SOUND_ON_FIRE] = {'CHAR_SOUND_ON_FIRE_1.ogg','CHAR_SOUND_ON_FIRE_2.ogg'},
[CHAR_SOUND_OOOF] = 'CHAR_SOUND_OOOF.ogg',
[CHAR_SOUND_OOOF2] = 'CHAR_SOUND_OOOF2_2.ogg',
[CHAR_SOUND_PANTING] = {'CHAR_SOUND_PANTING_1.ogg', 'CHAR_SOUND_PANTING_2.ogg','CHAR_SOUND_PANTING_3.ogg'},
[CHAR_SOUND_PANTING_COLD] = 'CHAR_SOUND_PANTING_COLD.ogg',
[CHAR_SOUND_PUNCH_HOO] = 'CHAR_SOUND_PUNCH_HOO.ogg',
[CHAR_SOUND_PUNCH_WAH] = 'CHAR_SOUND_PUNCH_WAH.ogg',
[CHAR_SOUND_PUNCH_YAH] = 'CHAR_SOUND_PUNCH_YAH.ogg',
[CHAR_SOUND_SO_LONGA_BOWSER] = 'CHAR_SOUND_SO_LONGA_BOWSER.ogg',
[CHAR_SOUND_SNORING1] = 'CHAR_SOUND_SNORING1.ogg',
[CHAR_SOUND_SNORING2] = 'CHAR_SOUND_SNORING2.ogg',
[CHAR_SOUND_SNORING3] = {'CHAR_SOUND_SNORING2.ogg', 'CHAR_SOUND_SNORING1.ogg', 'CHAR_SOUND_SNORING3.ogg'},
[CHAR_SOUND_TWIRL_BOUNCE] = 'CHAR_SOUND_TWIRL_BOUNCE.ogg',
[CHAR_SOUND_UH] = 'CHAR_SOUND_UH.ogg',
[CHAR_SOUND_UH2] = 'CHAR_SOUND_UH2.ogg',
[CHAR_SOUND_UH2_2] = 'CHAR_SOUND_UH2_2.ogg',
[CHAR_SOUND_WAAAOOOW] = 'CHAR_SOUND_WAAAOOOW.ogg',
[CHAR_SOUND_WAH2] = 'CHAR_SOUND_WAH2.ogg',
[CHAR_SOUND_WHOA] = 'CHAR_SOUND_WHOA.ogg',
[CHAR_SOUND_YAHOO] = 'CHAR_SOUND_YAHOO.ogg',
[CHAR_SOUND_YAWNING] = 'CHAR_SOUND_YAWNING.ogg',
[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'CHAR_SOUND_YAHOO.ogg', 'CHAR_SOUND_YAHOO_WAHA_YIPPEE_1.ogg', 'CHAR_SOUND_YAHOO_WAHA_YIPPEE_2.ogg', 'CHAR_SOUND_YAHOO_WAHA_YIPPEE_3.ogg'},
[CHAR_SOUND_YAH_WAH_HOO] = { 'CHAR_SOUND_YAH_WAH_HOO_1.ogg', 'CHAR_SOUND_YAH_WAH_HOO_2.ogg', 'CHAR_SOUND_UH2.ogg'},
}

local capBOWSETTE = {
    normal = smlua_model_util_get_id("bowsettes_cap_geo"),
    wing = smlua_model_util_get_id("bowsettes_wing_cap_geo"),
    metal = smlua_model_util_get_id("bowsettes_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bowsettes_metal_wing_cap_geo")
}

local PALETTE_BOWSETTE = {
    [SHIRT] = "ffffff",
    [SHOES] = "40343E",
    [HAIR] = "E85E44",
    [CAP] = "AB97A2",
    [PANTS] = "428119",
    [GLOVES] = "ffffff",
    [SKIN] = "BD7739",
}

_G.charSelect.character_add_caps(E_MODEL_BOWSETTE, capBOWSETTE)

if _G.charSelectExists then
    CT_BOWSETTE = _G.charSelect.character_add("Bowsette", "Evil Queen of the Koopas! Strong! Pretty! Irreristible to women! Voiced by Gauntlet Queen", "Melzinoff & Gauntlet Queen", {r = 239, g = 128, b = 177}, E_MODEL_BOWSETTE, CT_MARIO, TEX_BOWSETTE)

    _G.charSelect.character_add_palette_preset(E_MODEL_BOWSETTE, PALETTE_BOWSETTE)
    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_BOWSETTE, VOICETABLE_BOWSETTE)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BOWSETTE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BOWSETTE then return _G.charSelect.voice.snore(m) end
    end)



    -- table to associate animation IDs with our registered lua animation names
    local bowsetteplayerAnims = {
        [CHAR_ANIM_RUNNING] = 'bowsette_running',
       -- [CHAR_ANIM_IDLE_HEAD_CENTER] = 'bowsette_idle_head_center',
       -- [CHAR_ANIM_IDLE_HEAD_LEFT] = 'bowsette_idle_head_left',
       -- [CHAR_ANIM_IDLE_HEAD_RIGHT] = 'bowsette_idle_head_right',
       -- [CHAR_ANIM_BACKWARD_KB] = 'bowsette_backward_kb',
       -- [CHAR_ANIM_FIRST_PERSON] = 'bowsette_first_person',
        [CHAR_ANIM_FLUTTERKICK] = 'bowsette_flutterkick',
        [CHAR_ANIM_FLUTTERKICK_WITH_OBJ] = 'bowsette_flutterkick_with_obj',
        --[CHAR_ANIM_FORWARD_KB] = 'bowsette_forward_kb',
       -- [CHAR_ANIM_GROUND_BONK] = 'bowsette_ground_bonk',
       -- [CHAR_ANIM_GROUND_KICK] = 'bowsette_ground_kick',
       -- [CHAR_ANIM_GROUND_THROW] = 'bowsette_ground_throw',
       -- [CHAR_ANIM_HEAVY_THROW] = 'bowsette_heavy_throw',
       -- [CHAR_ANIM_MISSING_CAP] = 'bowsette_missing_cap',
        --[CHAR_ANIM_PULL_DOOR_WALK_IN] = 'bowsette_pull_door_walk_in',
        [CHAR_ANIM_RELEASE_BOWSER] = 'bowsette_release_bowser',
        [CHAR_ANIM_RETURN_FROM_STAR_DANCE] = 'bowsette_return_from_star_dance',
        --[CHAR_ANIM_RETURN_STAR_APPROACH_DOOR] = 'bowsette_return_star_approach_door',
       -- [CHAR_ANIM_SLIDEFLIP_LAND] = 'bowsette_sideflip_land',
        [CHAR_ANIM_SLEEP_IDLE] = 'bowsette_sleep_idle',
        [CHAR_ANIM_START_SLEEP_SITTING] = 'bowsette_sleep_sitting',
       -- [CHAR_ANIM_SOFT_BACK_KB] = 'bowsette_soft_back_kb',
        --[CHAR_ANIM_SOFT_FRONT_KB] = 'bowsette_soft_front_kb',
        [CHAR_ANIM_STAR_DANCE] = 'bowsette_star_dance',
        --[CHAR_ANIM_START_CROUCHING] = 'bowsette_start_crouch',
        --[CHAR_ANIM_STOP_CROUCHING] = 'bowsette_stop_crouch',
        --[CHAR_ANIM_START_SLEEP_IDLE] = 'bowsette_start_sleep',
        --[CHAR_ANIM_STOP_SLIDE] = 'bowsette_stop_slide',
        --[CHAR_ANIM_SUMMON_STAR] = 'bowsette_summon_star',
        [CHAR_ANIM_SWIM_WITH_OBJ_PART1] = 'bowsette_swim_with_obj1',
        [CHAR_ANIM_SWIM_WITH_OBJ_PART2] = 'bowsette_swim_with_obj2',
       -- [CHAR_ANIM_TRIPLE_JUMP_LAND] = 'bowsette_triple_jump_land',
        --[CHAR_ANIM_TURNING_PART1] = 'bowsette_turning_part1',
        --[CHAR_ANIM_TURNING_PART2] = 'bowsette_turning_part2',
        --[CHAR_ANIM_TWIRL_LAND] = 'bowsette_twirl_land',
        --[CHAR_ANIM_WAKE_FROM_LYING] = 'bowsette_wake_from_lying',
        --[CHAR_ANIM_WAKE_FROM_SLEEP] = 'bowsette_wake_from_sleep',
        --[CHAR_ANIM_CREDITS_RAISE_HAND] = 'bowsette_credits_raise_hand',
        --[CHAR_ANIM_CREDITS_RETURN_FROM_LOOK_UP] = 'bowsette_credits_return_from_look_up',
        --[CHAR_ANIM_CREDITS_START_WALK_LOOK_UP] = 'bowsette_credits_start_walk_look_up',
        --[CHAR_ANIM_CREDITS_TAKE_OFF_CAP] = 'bowsette_credits_take_off_cap',
        --[CHAR_ANIM_DYING_FALL_OVER] = 'bowsette_dying_fall_over',
        --[CHAR_ANIM_FALL_OVER_BACKWARDS] = 'bowsette_fall_over_backwards',
        --[CHAR_ANIM_FAST_LEDGE_GRAB] = 'bowsette_fast_ledge_grab',
        --[CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN] = 'bowsette_final_bowser_raise_hand_spin',
        --[CHAR_ANIM_FIRST_PUNCH_FAST] = 'bowsette_first_punch_fast',
        --[CHAR_ANIM_GENERAL_LAND] = 'bowsette_general_land',
        --[CHAR_ANIM_HEAD_STUCK_IN_GROUND] = 'bowsette_head_stuck_in_ground',
       -- [CHAR_ANIM_LAND_FROM_DOUBLE_JUMP] = 'bowsette_land_from_double_jump',
       -- [CHAR_ANIM_LAND_FROM_SINGLE_JUMP] = 'bowsette_land_from_single_jump',
       -- [CHAR_ANIM_LAND_ON_STOMACH] = 'bowsette_land_on_stomach',
       -- [CHAR_ANIM_LEGS_STUCK_IN_GROUND] = 'bowsette_legs_stuck_in_ground',
       -- [CHAR_ANIM_PLACE_LIGHT_OBJ] = 'bowsette_place_light_obj',
       -- [CHAR_ANIM_PUSH_DOOR_WALK_IN] = 'bowsette_push_door_walk_in',
       -- [CHAR_ANIM_PUT_CAP_ON] = 'bowsette_put_cap_on',
        [CHAR_ANIM_RUN_WITH_LIGHT_OBJ] = 'bowsette_run_with_light_obj',
        --[CHAR_ANIM_SECOND_PUNCH_FAST] = 'bowsette_second_punch_fast',
       -- [CHAR_ANIM_SHIVERING_RETURN_TO_IDLE] = 'bowsette_shivering_returning_to_idle',
        [CHAR_ANIM_SKID_ON_GROUND] = 'bowsette_skid_on_ground',
        --[CHAR_ANIM_SLOW_LAND_FROM_DIVE] = 'bowsette_slow_land_from_dive',
        --[CHAR_ANIM_SLOW_LEDGE_GRAB] = 'bowsette_slow_ledge_grab',
        --[CHAR_ANIM_SLOW_WALK_WITH_LIGHT_OBJ] = 'bowsette_slow_walk_with_light_obj',
        --[CHAR_ANIM_STAND_UP_FROM_LAVA_BOOST] = 'bowsette_stand_up_from_lava_boost',
        --[CHAR_ANIM_STOP_SKID] = 'bowsette_stop_skid',
        --[CHAR_ANIM_TAKE_CAP_OFF_THEN_ON] = 'bowsette_take_cap_off_then_on',
        --[CHAR_ANIM_THROW_CATCH_KEY] = 'bowsette_throw_catch_key',
        [CHAR_ANIM_WALK_WITH_LIGHT_OBJ] = 'bowsette_walk_with_light_obj',
        --[CHAR_ANIM_BOTTOM_STUCK_IN_GROUND] = 'bowsette_bottom_stuck_in_ground',
        --[CHAR_ANIM_CREDITS_PEACE_SIGN] = 'bowsette_credits_peace_sign',
        [CHAR_ANIM_FIRE_LAVA_BURN] = 'bowsette_fire_lava_burn',
        --[CHAR_ANIM_GROUND_POUND] = 'bowsette_ground_pound',
        --[CHAR_ANIM_GROUND_POUND_LANDING] = 'bowsette_ground_pound_landing',
        --[CHAR_ANIM_TRIPLE_JUMP_GROUND_POUND] = 'bowsette_triple_jump_ground_pound_anim',
        --[CHAR_ANIM_UNLOCK_DOOR] = 'bowsette_unlock_door',
        [CHAR_ANIM_SWINGING_BOWSER] = 'bowsette_swinging_bowser',
        [CHAR_ANIM_HOLDING_BOWSER] = 'bowsette_holding_bowser',
        [CHAR_ANIM_GRAB_BOWSER] = 'bowsette_grab_bowser',
        --[CHAR_ANIM_BEND_KNESS_RIDING_SHELL] = 'bowsette_dressfloating',

    }

    
    if _G.bowsMoveset ~= nil then
        -- Retrieves the custom shell model for this character. Check template_shell.blend for how to set up a shell model properly.
         local E_MODEL_BOWSETTE_SHELL = smlua_model_util_get_id("bowsette_shell_geo")
        
    
        -- This is a bitfield of flags that decide which parts of the Bowser Moveset this character will have.
        -- Insert each flag you want to be set, separated by '|' symbols.
        local BOWS_FLAGS_BOWSETTE =
        _G.bowsMoveset.FLAG_CAN_USE_FIREBALL | _G.bowsMoveset.FLAG_CAN_USE_SHELL | _G.bowsMoveset.FLAG_NO_CAPLESS | _G.bowsMoveset.FLAG_HEAVY_STEPS
    
        -- Flag Options: (sorry the ids are so long pshgkjdf)
    
        -- _G.bowsMoveset.FLAG_CAN_USE_SHELL
        --- Allows the character to use the shell slide ability.
    
        -- _G.bowsMoveset.FLAG_CAN_USE_FIREBALL
        --- Allows the character to use the fire breath ability.
    
        -- _G.bowsMoveset.FLAG_STYLE_ANIMS
        --- Enables Bowser-unique animations for the character.
    
        -- _G.bowsMoveset.FLAG_SIZE_ANIMS
        --- Adjusts the character's pose in certain animations to suit bowser's large size. (i.e. ledge grab)
    
        -- _G.bowsMoveset.FLAG_LARGE_HITBOX
        --- Gives the character a larger hitbox size. (37 -> 85 units radius)
        --- This does not affect the hitbox size for level collision, only collisions with objects.
    
        -- _G.bowsMoveset.FLAG_NO_CAPLESS
        --- The character does not visually lose their 'cap'. Will also use their 'capless' head state in some animations.
        --- Used by Bowser to allow his jaw to open when breathing fire, etc.
    
        -- _G.bowsMoveset.FLAG_HEAVY_STEPS
        --- Enables heavier landing sound effects for the character.
    
        -- _G.bowsMoveset.FLAG_ATTACKS
        --- Enables the alternate sliding punch.
    
        -- _G.bowsMoveset.FLAG_ALL
        --- Shorthand to set all flags.
    
            -- This function sets up your custom shell model. Feel free to remove this if you aren't using a shell model.
            -- parameters: [your character model], [your shell model]
            _G.bowsMoveset.character_add_shell_model(E_MODEL_BOWSETTE, E_MODEL_BOWSETTE_SHELL)
       
            -- This function sets up the flags for your character.
            -- parameters: [your character model], [your flag bitfield]
            _G.bowsMoveset.character_set_bows_flags(E_MODEL_BOWSETTE, BOWS_FLAGS_BOWSETTE)
  
        end


    local function mario_update(m)

    if gPlayerSyncTable[m.playerIndex].bowsetteplayer then
            local animID = m.marioObj.header.gfx.animInfo.animID

            -- replaced animations
            local luaAnimID = bowsetteplayerAnims[animID]
            if luaAnimID then
                -- if the current anim ID has a valid lua anim ID associated with it, play the custom animation
                smlua_anim_util_set_animation(m.marioObj, luaAnimID)
            end

        end
    end
    hook_event(HOOK_MARIO_UPDATE, mario_update)
    
    hook_event(HOOK_UPDATE, function()
        -- flag to determine if a player is bowsette (boolean)
        -- this is done in the local update hook because character select can only check for the local player's numbers
        -- gPlayerSyncTable auto syncs the result to all clients
        gPlayerSyncTable[0].bowsetteplayer = (_G.charSelect.character_get_current_number() == CT_BOWSETTE)
    end)

else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
